( -*- forth -*- )
( picstamp led blinking examples )

target incremental

( busy wait timing
core is running at 48MHz, this gives 12MIPS
a '0 for next' loop compiles to:

        7FC0 6AE4       clrf    PREINC1, A
        7FC2 06E7       decf    INDF1, F, A
        7FC4 E1FE       bnz     7FC2    
        7FC6 52E5       movf    POSTDEC1, F, A

to see this, type
        { 0 for next }
followed by
        .scratch

the loop is executed 256 times [because the loop is
executed at least once, then the counter is decremented,
which wraps 0 to 255]

decf takes 1, bnz takes 2 cycles, so the whole
loop takes approximately 768 clocks, or about 64 usec.

wait is defined as:
: wait 0 for 0 for next next ;

so takes about 16 msec. we could define second as )


: sec ( n -- ) for [ 1000 16 / ]L for wait next next ;


( similarly, we can define a millisecond interval as
a multiple of '0 for next' the constant computes to 15 )

: ms ( n -- ) for [
    12000000  ( mips )
    3 256 *   ( '0 for next' cycles )
    1000 * /  ( milliseconds )
    ]L for 0 for next next next ;

( wait interval for blinking )
: w   250 ms ;


( grey code counter )
: xa  red   toggle w ;
: xb  green toggle w ;
: xc  blue  toggle w ;

: a   xa ;
: b   a xb a ;
: c   b xc b xc ;

