( -*- forth -*- )

( picstamp monitor )

48 MHz constant fosc
19200  constant baud

( target forth )
load stc16/stc.f             ( macros )
load stc16/serial_simple.f   ( no interrupts )
load stc16/program.f         ( flash programming )
load stc16/execute.f         ( xt vectors )
load stc16/interpreter.f     ( simple xt interpreter + support )


( picstamp stuff )
macro
: red   LATB 0 ;
: green LATB 1 ;
: blue  LATB 2 ;

target

: initstamp 0xf8 TRISB and! ;
: wait      0 for 0 for next next ;
: rgb       0xf8 PORTB and! PORTB or! ;
: kitt<     0x1 4 for dup rgb wait rot< next drop ;
: kitt>     0x4 4 for dup rgb wait rot> next drop ;
: kitt      kitt< kitt> ;


( entry point )
: main
    initstacks      ( setup DS RS XS )
    initserial      ( init serial port )
    initstamp kitt  ( stamp stuff )
    interpreter     ( start interpreter )
    [ 0x200 call, ] ( fall through to shifted reset vector ) ;

( set reset and interrupt vectors )
' main 0x0 vector!
0x0208 0x4 vector!
0x0218 0xc vector!

host

( now dump out the dictionary for the monitor,
so it can be loaded later without recompiling
and uploading. )

saveforth image/picstamp.f
savehex   hex/picstamp.hex


( host interactive support code )
( load host/interactive.f
load wisp/18f452.f )



( config bits usbstamp:
0x300000 21
0x300001 0F
0x300002 3E
0x300000 1E )

