( -*- forth -*- )

( 14bit disassembler

attention: we still use byte addresses, to
keep more things shared between the 16bit and 14bit cores )

host

load host/dasm.f

: .reg ( x -- x )
    uppercase
    dup 0x7f and opcode
    FSR INDF GPIO TRISIO INTCON TMR0 STATUS
    PCL PCLATH
    found? not if .7bit then drop lowercase ;


( 1 word opcodes )
: .opcode ( opcode -- )
    
    ( 0 bit operand )
    opcode
    NOP RETURN SLEEP RETFIE CLRWDT
    
    found? if 2drop exit then

    ( 7 bit address )
    0xff80 mask opcode
    MOVWF CLRF
    found? if drop space tab .reg 2drop exit then or

    ( 8 bit literal )
    0xff00 mask opcode
    MOVLW ADDLW ANDLW SUBLW IORLW XORLW RETLW
    found? if drop space tab .8bit 2drop exit then or

    ( 7 bit literal + dest )
    0xff00 mask opcode
    MOVF ADDWF SUBWF ANDWF IORWF XORWF INCF DECF INCFSZ
    DECFSZ RLF RRF SWAPF COMF
    found? if drop tab .reg ,space 2 << .dest 2drop exit then or

    ( 3/7 bit tests )
    0xfc00 mask opcode
    BSF BCF BTFSC BTFSS
    found? if drop tab .reg ,space 1 << .3bit 2drop exit then or


    ( 11 bit jumps )
    0xf800 mask opcode
    GOTO CALL
    found? if drop tab dup 2 * .address 2drop exit then or

    ( unknown opcode )
    space .word drop
;


variable last-dasm
0 last-dasm h!

: .dasm ( start end )
    >r r last-dasm h!
    begin
	dup r < while
	    dup .code space
	    dup t@ .word tab
	    dup dup t@ .opcode
	    2 + cr
    repeat drop rdrop ;

: .d
    dup 0x20 + .dasm ;
: more
    last-dasm h@ dup 0x20 + .dasm ;

: savedasm
    output-file 0 there .dasm output-close ;

: tsee
    accept (tfind)
    dup 0 = if drop 0x20 then ( no length recorded? -> use default )
    over + .dasm ;
: see# tsee ;
