( -*- forth -*- )
( dtc boot code )

host

( these will be set in the highlevel boot/int words )
variable RST
variable IHI
variable ILO

: vector  there swap h! [t'] next compile, ; ( default is nop )

( compile forth word ISR. the word needs to end with a
  tailcall to ret )
: icall, ( addr -- )
    [t'] (ienter) call, ( call context save. restore is done in iret primitive )
    lohi imm, push=w, imm, push=w,  ( load hi and lo on ds )
    [t'] execute   ( get execute address )
    jump, ;        ( jump to execute )



( high level boot code )
target

: boot  [ RST vector ] exit [
: ihigh [ IHI vector ] iexit ;
: ilow  [ ILO vector ] iexit ;

tword _reset <t'> reset compile,

( low level boot code
  this is interleaved with interrupt vectors: indented )
host
there 0x0000 there!

( setup stacks )
data 0 lfsr,     ( 0000 ) ( set DST=data )
0 imm,           ( 0004 ) ( set w=0 )
  0x000a rjump,  ( 0006 ) ( branch over inthi vector )
  there rjump,   ( 0008 ) ( set intlo vector )
STKPTR store,    ( 000a ) ( set RST=0 )

( setup reset word )
<t'> _reset lohi ( get reset word )
imm,             ( 000c ) ( set w=hi )
iph=w,           ( 000e ) ( store in ip )
imm,             ( 0010 ) ( set w=lo )
ipl=w,           ( 0012 ) ( store in ip )

( setup boot call )
<t'> boot lohi   ( get highlevel boot word )
imm,             ( 0014 ) ( set w=hi )
  0x001a rjump,  ( 0016 ) ( jump over intlo vector )
  there rjump,   ( 0018 ) ( set inthi vector )
push=w,          ( 001a ) ( load on ds )
imm,             ( 001c ) ( set w=lo )
push=w,          ( 001e ) ( load on ds )
<t'> execute     ( get execte address )
jump,            ( 0020 ) ( jump to execute )


( mechanism to call highlevel words from primitives

this could be done by
* calling and providing an explicit ret word
* adding an explicit return cell, and entering it

we choose the second, since it's simpler and we
only need to call 2 words, and we can put iret in there. )

( compile ihigh and ilow threaded code calls
  and environment save/restore )
there <t'> ilow icall,
there <t'> ihigh icall,

( patch the addresses )
0x0008 there! rjump,
0x0018 there! rjump,

there!         ( restore there )


( code to install reset vectors )
: install-reset RST h@ t! ; ( word -- )
: install-ihigh IHI h@ t! ;
: install-ilow  ILO h@ t! ;

    

