( -*- forth -*- )
( dtc register macros )

( bit less error prone names )
: fetch,     movf, ;
: store,     movwf, ;
: move,      movff, ;
: imm,       movlw, ;


( data stack )
: push=w,     PREINC0 store, ;
: w=pop,      POSTDEC0 fetch, ;


( indirect addressing )
: ah=w,      FSR2H store, ;
: al=w,      FSR2L store, ;
: w=ah,      FSR2H fetch, ;
: w=al,      FSR2L fetch, ;
: w=*a++,    POSTINC2 fetch, ;
: w=*a,      INDF2 fetch, ;
: *++a=w,    PREINC2 store, ;
: *a++=w,    POSTINC2 store, ;
: a--,       FSR2L decf, f, ;
: *a=w,      INDF2 store, ;

( return stack )
: w=TOSL,    TOSL fetch, ;
: w=TOSH,    TOSH fetch, ;
: TOSL=w,    TOSL store, ;
: TOSH=w,    TOSH store, ;

( instruction pointer )
: iph=w,     TBLPTRH store, ;
: ipl=w,     TBLPTRL store, ;
: w=iph,     TBLPTRH fetch, ;
: w=ipl,     TBLPTRL fetch, ;
: iph=TOSH,  TOSH TBLPTRH move, ;
: ipl=TOSL,  TOSL TBLPTRL move, ;
: w=*ip++,   TBLRD*+ , TABLAT fetch, ;
: pch=w,     PCLATH store, ;
: pcl=w,     PCL store, ;

( misc )
: d[],       movlw, PLUSW0 fetch, ;
: w=d[1],    -1 d[], ;
: w=d[3],    -3 d[], ;
: w+=4,      4 addlw, ;
: w=d[1]+4,  w=d[1], w+=4, ;      ( map d[1] to data space, leave in w )
