( -*- forth -*- )
( primitive factors )
  
( convention: words with parenthesis are primitive factors:
they don't end in next, but use the HW return stack. )

( enter forth from interrupt. this saves all the registers
  used in the primitives )
: (ienter)
    push=w
    [ STATUS ] fetch push=w
    w=ah push=w
    w=al push=w
    [ 0 ] fetch push=w
    [ 1 ] fetch push=w
    [ 2 ] fetch push=w
    [ 3 ] fetch push=w
;

: (a!)   a! ;                      ( a -- ) ( real address )
: (da!)  w=d[1]+4 [                ( a -- ) ( virtual address )
: (wa!)  ah=w w=pop al=w w=pop ;   ( take low byte from stack, high byte from w )

: (@ip+) w=*ip++ push=w w=*ip++ push=w ;
: (ip!)  w=pop ipl=w w=pop iph=w ;

: (>x)       w=pop [ x0 store, ] w=pop   [ x1 store, ] ;           ( x -- )
: (>yx) (>x) w=pop [ y0 store, ] w=pop   [ y1 store, ] ;           ( y x -- )
: (y@)  w=*a++     [ y1 store, ] w=*a    [ y0 store, ] a-- ;       ( leaves a intact )
: (x>)             [ x1 fetch, ] push=w  [ x0 fetch, ] push=w ;    ( -- x )

: (+)   [ ADDWFC ADDWF yx>y, ] ;
: (-)   [ SUBWFB SUBWF yx>y, ] ;
: (or)  [ IORWF  IORWF yx>y, ] ;
: (xor) [ XORWF  XORWF yx>y, ] ;
: (and) [ ANDWF  ANDWF yx>y, ] ;

( this patches the address to data space:
  ops on program memory not allowed )
: (@>yx) (da!) (y@) (>x)  ;


    
