( -*- forth -*- )

( dtc kernel primitives )
( inner interpreter )

: nop [
: next w=*ip++ pch=w w=*ip++ pcl=w [

( x y regs )    
: y>   [ y1 fetch, ] push=w  [ y0 fetch, ] push=w next ; ( -- y )
: y!   [ y1 fetch, ] *a++=w  [ y0 fetch, ] *a++=w next ; ( increments a )

( stack ops )
: drop  w=pop w=pop next ;
: dup   w=d[1] push=w w=d[1] push=w next ;
: over  w=d[3] push=w w=d[3] push=w next ;
: swap  (>yx) (x>) y> ;


( rs ops, using mostly macros. this should
  be the only place with significant asm code dup )
: r>       _r pop next ;
: r        _r next ;
: >r       _>r next ;
: execute  _>r ;


( each highlevel word contains a call to ENTER )
: enter  r<>ip next ;
    ( swap TOSH:TOSL with TBLPTRH:TBLPTRL
      each highlevel word starts with call enter )
: exit     r>ip next ;
: lit      (@ip+) next ;
: pass     (@ip+) r>ip execute ;
: bra      (@ip+) (ip!) next ;
: skip     [ TBLRD*+ , TBLRD*+ , ] next ;

: bra0     w=pop [ POSTDEC0 iorwf, ] _ifz bra _other skip ;
: (next)
    ( FIXME: this can be simpler )
    [ 0 imm, ]
    [ TOSL decf, f, ]
    [ TOSH subwfb, f, ]
    [ TOSH movf, ]
    [ TOSL iorwf, ]
    _ifnz bra _other pop skip ;


( a constant is a call to doconst followed by
  the constant in memory )
: doconst  r<>ip (@ip+) exit ;


( @ and ! should unify program and data memory.
in order to do this, data and control memory are
2mapped to 0xfc00-0xffff )


: @
    w=d[1]+4 _ifc (wa!) @a+ next           ( data )
    _other push r<>ip (ip!) (@ip+) exit ;  ( program )

( store to program memory not supported.
this will address mod 0x400 )
: ! (da!) !a next ;


( control regs: these use real addresses )
: c@  (a!) [ 0 ] imm push=w w=*a push=w next ;
: c!  (a!) w=pop *a=w w=pop next ;

: +    (>yx) (+)   y> ;
: -    (>yx) (-)   y> ;
: or   (>yx) (or)  y> ;
: xor  (>yx) (xor) y> ;
: and  (>yx) (and) y> ;

: +!    (@>yx) (+) y! ;
: -!    (@>yx) (-) y! ;
: or!   (@>yx) (or)  y! ;
: xor!  (@>yx) (xor) y! ;
: and!  (@>yx) (and) y! ;


( exit from forth and return from interrupt )
: iexit
    w=pop [ 3 ] store
    w=pop [ 2 ] store
    w=pop [ 1 ] store
    w=pop [ 0 ] store
    w=pop al=w
    w=pop ah=w
    w=pop [ STATUS ] store
    [ POSTDEC0 WREG ] move ( don't use movf because it changes flags )
    [ RETFIE , ]
; 

( reset processor )
: reset    [ RESET ,

