( -*- forth -*- )

( 16bit big endian direct threaded forth compiler )


( endianness 

a simple next requires the bytes to be in HI,LO order.
a simple execute requires the stack bytes to be in LO,
HI order.
stack grows upwards
a simple fetch gives HI,LO to HI,LO stack image.
so all data in memory will be big endian, with a slower
execute, using push and return instead of PCL.

for arithmic it doesn't really matter since temp regs
are used. )

host

variable _notail
: notail there _notail h! ; notail

: swaplohi dup
    8 << 0xff00 and swap
    8 >> 0x00ff and or ;

( from here on all target ops are big endian )
<h'> t@ : t@ [ _ ] swaplohi ;
<h'> t! : t! >r swaplohi r> [ _ ] ;
<h'> ,  : ,  swaplohi [ _ ] ;

: compile,   , ;
: lit,       [t'] lit compile, , ;
: enter,     [t'] enter call, ;  ( this is still little endian: native code )

( this must perform tail recursion
FIXME: special cases:
* literals
* empty words
* jump targets
* other words that read ip )

: notail? there _notail h@ = ;    ( check if tail opti is ok ) 

: :# tword enter, notail ] ;
: ;,
    notail? if [t'] exit , else
    prev t@ [t'] pass prev t! , then [_ ;

( set vectors )
<h'> lit,     <lit,> h!
<h'> compile, <compile,> h!