( -*- forth -*- )

( disassembler shared code )

host
: .opcode ( opcode ) ;


( if match, print and rdrop exit,
else continue after 0 )

variable xts
: @xt  xts h@ h@ ;
: xt+  4 xts h+! ;


: done    begin @xt 0 = xt+ until xts h@ ;

: match? ( opcode xt -- )
    >r dup r execute = r> swap ;

variable <.string>
: lowercase vector <.string> .lowstring ;
: uppercase vector <.string> .string ;
lowercase


: opcode ( opcode )
    r> xts h!
    begin
	@xt ( opcode xt )
	match? if rfind <.string> h@ execute -1 done >r exit else drop then
    xt+ @xt 0 = until
    0 done >r ;

: found?_ 0 _ ;


( opcode opcodemask operandmask -- operand opcode )
: split >r >r dup r> and swap r> and swap ;

( opcode opcodemask -- operand opcode )
: mask dup not 0xffff and split ;
: ,space [c] , emit space ;

: .11bit   dup 0x3ff and .word ;
: .8bit    dup 0xff  and .byte ;
: .7bit    dup 0x7f  and .byte ;
: .3bit    dup 0x700 and 8 >> >hex emit ;
: .banked  dup 0x100 and if [c] B  else [c] A  then emit ;
: .dest    dup 0x200 and if [c] F  else [c] W  then emit ;


: .codename   rfind dup if 0x3b emit space dup .string then ;
: .address    dup .word tab .codename drop ;

: .code       dup .codename if cr then tab .word ;

: .8jump   2dup 24 << 23 >> + 2 + .address ;
: .11jump  2dup 21 << 20 >> + 2 + .address ;

