( -*- forth -*- )
( intel hex file output, replacement for the C code )


variable checksum ( line checksum )


: .byte
    dup checksum h+!
    dup 4 >> >hex emit >hex emit ;

: .end
    checksum h@ neg .byte ( line checksum )
    13 emit 10 emit ;     ( DOS newlines )

: .word dup 8 >> .byte .byte ;

: .start ( type address length -- )
    0 checksum h!       ( reset line checksum )
    [c] : emit          ( start char )
    .byte .word .byte ;
    

: .address ( address -- )
    4 0 2 .start .word .end ;
    
: .done
    1 0 0 .start .end ;


variable readout ( current target code reading point )

( dump next line )
: .line >r ( length -- )
    0 readout h@ r .start
    readout h@ r> for dup t@ .byte 1 + next  readout h!
    .end ;

( dump code )
: .hex
    >r dup readout h! .address
    r readout h@ - 0x10 / dup if
	for 0x10 .line next  else drop then  ( full lines )
    r> readout h@ - dup if
	.line else drop then                 ( partial line )
    .done ;

: savehex
    output-file 0 there .hex output-close ;



( target forth dump )

: digits for dup 28 >> >hex emit 4 << next  ;
: .4x space [c] 0 emit [c] x emit 16 << 4 digits drop ;
: .2x space [c] 0 emit [c] x emit 24 << 2 digits drop ;

: entry swap accept (tdict) erecord ;
: org   there! ;

: .tcode
    0 . space 
    [c] o emit
    [c] r emit
    [c] g emit cr
    0 there 2 / for
    dup t@ .4x space [c] , emit
    2 + dup 0xf and 0 = if
	space 0x28 emit
	dup 0x10 - .x
	space 0x29 emit
	cr
    then
    next drop cr ;

: .tforth .tdict .tcode ;
: saveforth output-file .tforth output-close ;

    
: [saveforth]_ [output-file]_ .tforth_ output-close_ ;

