( -*- forth -*- )
( some forth constructs
most of them are not necessary in simple apps, so
they are optional )

host
: dp,  FSR, ;
: top, INDF, ;


target


( temp regs )


variable x   ( arg1 )
variable y   ( arg2 )
variable z   ( saved dp )

( since we can't put data on the return stack, this comes in handy
note that x and y are not saved in the isr, so if you use swap
you need to save them )

( 1 level forth ops )
: x@y@   x @ y @ ;
: swap   x ! y ! x@y@ ;
: over   x ! top y @! x@y@ ;

macro

( WARNING:
indirect addressing uses FSR, so temporarily disables
the data stack. if you use an isr that uses the data
stack, you need to
* re-enable cli/sti in the macros below
* use a separate data stack for the isr )

: save    dp z @! ( cli ) ;
: restore z dp @! ( sti ) ;

target



: (@)
    top x @!    ( x = address )

    save
    x dp  @!    ( dp = address )
    top x @!    ( x = *address )
    restore

    x top @! ;  ( top = *address )
    
: (!)
    x !         ( x = address )
    y !         ( y = value )

    save
    x dp @!     ( dp = address )
    y top @!    ( *address = value )
    restore ;
    

( redefine @, and !, )

host
: old_ if_ swap _ exit_ then_ ;

<h'> @,  : @, lit? old (@), ;
<h'> !,  : !, lit? old (!), ;

target
: (or)  [ INDF movf, drop, INDF iorwf, f, ] ;
: (and) [ INDF movf, drop, INDF andwf, f, ] ;

( redefine or, and and, )
host
<h'> or,  : or,  lit? old (or), ;
<h'> and, : and, lit? old (and), ;


target

( fill data stack to fill mem, then reset FSR )
: clearmem  0x3a begin 0 swap 1- 0? until 0x60 FSR ! ;  



