( -*- forth -*- )

( some math routines for 16bit operations )

( for pwm, a fractional multiply would be handy.
it's best to keep the fraction at 8 bit, for
ease of manipulation and speed.

currently, i don't see how to do this in a sane
way, meaning where to put the operations and how
to interface to the reset of forth

algo:
* set ah:al to full scale
* from LSB to MSB:
   * if set -> add full scale
   * shift x:y
)

( some regs to store operands )
variable a
variable ah
variable b
variable bh

host
: t7,        INDF lit, 7 lit, ;         ( top data stack bit 0 )
: RCR,   ( a -- )
    <lit, dup 1 + rrf, f, rrf, f, ;


( some register style math ops )

: ZERO, ( a -- )   ( *a=0 )
    <lit, dup clrf, 1 + clrf, ;

( some register ops for math:
  stack ops and indirect addressing are too expensive )
variable _a
variable _b
variable _c

: high  1 _a h+! 1 _b h+! 1 _c h+! ;
: 2args <lit, _b h! <lit, _a h! ;
: 3args <lit, _c h! 2args ;

: a _a h@ ;
: b _b h@ ;
: c _c h@ ;
    

: ADD3, ( a b c  -- ) ( c = a + b )
    3args
    a movf, b addwf,    ( add low part )
    c movwf,            ( store result )
    0x60 rlf, high      ( get carry in w, 0x60 reads as zero )
    a addwf, c addwf,   ( add high part and carry )
    c movwf,            ( store result )
;

: ADD2, ( a b -- ) ( b = a + b )
    2args
    a movf, b addwf, f,     ( add low part )
    0x60 rlf, high          ( get carry in w, 0x60 reads as zero )
    a addwf, b addwf, f, ;  ( add high part and carry )

: MOVE, ( a b -- ) ( b = a )
    2args
    a movf, b movwf, high
    a movf, b movwf, ;


target
( compute fractional multiply:
a = fraction * b
positive math )

: (step)
    clc b RCR         ( positive shift b reg )
    t7 high?          ( check high bit of fraction )
    if b a ADD2 then  ( add b if bit nonzero )
    r<<c ;            ( shift fraction, don't care about carry )

: (step4) (step) (step) (step) (step) ;

: (frac) a zero (step4) (step4) drop ;

host

