( -*- forth -*- )

( misc stuff taken out of stc.f )
( simple sequencer for 1 level deep tasks/coroutines
the word | is provided to 'yield' to the caller. next invocation
will continue after the point

overhead: jump table 2 + 1/yield )

variable yield-current
create yield-address 256 table

: yield-reset 0 yield-current h! ;
: yield-next  1 yield-current h+! ;
: yield@      yield-current h@ cells yield-address + h@ ;
: yield!      yield-current h@ cells yield-address + h! ;



( FIXME: need to set PCLATH )
: jump+w,    PCL, addwf, f, ;
: ijump,     movf, jump+w, ;
: jumptos,   INDF ijump, ;


: |, exit, there yield! yield-next ;

: end-sequence, ( jump var -- )
    0xff movlw, dup movwf, return,             ( reset ip )                ( jump var )
    swap there swap there! dup call, there!    ( patch call to here )      ( var )
    ijump,                                     ( compile jump into table ) ( )

    yield-current h@ yield-reset               ( compile jump table )
    for yield@ jump, yield-next next [, ;

: sequence# ( -- jump var terminator )
    accept tword            ( ignore : )
    there 0 call,           ( call to jump table )
    nextvar                 ( allocate state var )  ( jump var )
    1 movlw, dup addwf, f,  ( increment ip )
    return,                 ( return to caller )
    yield-reset             ( start recording a new table )
    there yield! yield-next ( entry point )
    ] [h'] end-sequence, ; ( load terminator )


( simpler version: jump table )
: end-jumptable, rdrop rdrop [, ;

: jumptable,
    [h'] end-jumptable,         ( load terminator on stack )
    ] begin accept interpret tailcall, again ;
    
: machine# ( variable -- )
    accept tword          ( ignore : )
    ijump,                ( compile jump )
    jumptable, ;

: jumptable# ( -- )
    accept tword
    jumptos,
    jumptable, ;

