( -*- forth -*- )
host

( the highlevel compiler )

( default compilation vectors
<lit,> and <compile,> are defined in kernel )
variable <exit,>

stack takeoffs
variable last-landing
: takeoff  there takeoffs push ;
: landing  there last-landing h! ;
: landing? there last-landing h@ = ;


: tailcall,   prev t@ 0x7ff and  GOTO or prev t! ;

( default handlers )

: (exit), call? if tailcall, exit then return, ;

( if we have a jump landing here, we can still optimize
the call before the then into a tailcall, but need to compile
a return )

: exit,
    landing? not if (exit), exit then 
    call? if tailcall, then return, ;

: compile, call, ;

( jump snapping
we keep a list of all forward jumps so we can snap
all jumps after the function is compiled. this does
not eliminate dead code though. )


: follow     0x3ff and 2 * t@ ;     ( GOTO -- OPCODE : follow a GOTO )
: jump?      0x3800 and GOTO = ;    ( opcode -- ?  )
: return?    RETURN = ;             ( opcode -- ?  )

( snap a jump instruction: opcode -- opcode )
: snap
    dup follow return? if drop RETURN exit then  ( end of chain )
    dup follow jump? not if exit then            ( end of chain )
    follow snap ;                                ( recurse )

( check all elements on the takeoffs stack )
: jump-opti
    takeoffs empty? if exit then     ( done )
    takeoffs pop dup t@
    dup jump? if snap swap t! else 2drop then
    jump-opti ;

    
: ;,
    <exit,> h@ execute
    there erecord        ( record end for see to work )
    jump-opti [_ ;

: default-exit     vector <exit,>    exit, ;
: default-compile  vector <compile,> compile, ; 

: :# default-exit default-compile tword ] ;



