( -*- forth -*- )

( see PicForth documentation for inspiration )

( bit level instructions )
( these are only literals, so i'm looking for a way
to have a forth like syntax + possibility to optimize as much
as possible into these fast literal instructions.

4 opti cases:

value bit   reg
I     I     I     ->  bitmask + indirect and/or
I     I     L     ->  bitmask + direct and/or
I     L     L     ->  if bsf, else bcf, then
L     L     L     ->  bsf, or bcf,


3 bit functions:
0/1 bit!
bit@
bitflip


)

( these are only implemented for literal args )
( runtime: ( reg bit -- )
: toggle, need-2lit btg, ;
: high,   need-2lit bsf, ;
: low,    need-2lit bcf, ;

( arguments need to be literals
save, is used before record, so this needs to be undone
by the rewinder using drop, 
TODO: the construct is optimizable by if, )


( condition generators )

: cond,  ( reg bit 1/0 -- )
    12 << >r            ( position polarity bit. 0 = BTFSS, 1 = BTFSC )
    save, record
    0 movlw,            ( 3prev )
    r> BTFSS or bitop,  ( 2prev )
    -1 movlw, ;         ( prev )

: <cond, ( -- reg bit 1/0 )
    2prev t@ >r
    r  0xff and      ( reg )
    r  9 >>  7 and   ( bit )
    r> 12 >> 1 and   ( 1/0 )
    rewind drop, ;

: cond?
    3prev t@ MOVLW =
    2prev t@ 0xE000 and BTFSS =
    prev  t@ MOVLW 0xff or =
    3last? and and and ;

: invert 2prev t@ 0x1000 xor 2prev t! ;
    

( runtime: ( reg bit -- ? )
: high?,  need-2lit 1 cond, ;
: low?,   need-2lit 0 cond, ;


: clc,      STATUS 0 bcf, ; ( clear carry )

