( -*- forth -*- )

host

( circular buffers )
variable bufferfree
buffers bufferfree h!   ( right after data and temp stacks )
: nextbuffer bufferfree h@ dup 0x10 + bufferfree h! ;

( create a circular buffer in the 'unreachable' part of bank0.
uses 16 bytes of memory. 1 state var, 1 guard byte.

state vars are packed: high nibble = read, low nibble = write

the created word loads the a reg with the buffer body. the
shared opterators assume a reg is the body. )


target

: read
    @a 0xf0 and nswap @i         ( fetch next item )
    @a 0x10 + c? if 0x10 + then  ( update ptr )
    !a ;                         ( store )
: write
    @a 0x0f and !i                          ( store next item )
    @a nswap 0x10 + c? if 0x10 + then nswap ( update ptr )
    !a ;

: clear 0x11 !a ;  ( clear buffer )

: (empty?) @a dup nswap xor nfdrop ;
: (full?)  @a dup nswap - 0x2e xor nfdrop ;

macro

: empty? (empty?) z? ;  ( buffer is empty )
: full?  (full?)  z? ;  ( buffer is full )
: ready? (empty?) nz? ; ( data ready for reading )
: room?  (full?)  nz? ; ( space available for writing )

host

: buffer#
    nextbuffer >r accept
    (tmacro)   enter_ r lit_ 2 lit_ lfsr,_ ;_    ( create target macro )
    (tcommand) enter_ r> lit_ ;_ ;
    
    
