( -*- forth -*- )

( stc 8bit forth

data stack:   W,FSR0
temp stack:   FSR1   [ balanced between calls ]
return stack: SPTR
address reg:  FSR2

during interrupts FSR2 needs to be saved. the data stack
can be used for saving.

data memory map:
0x000 - 0x07f:  access ram, global forth variables [immediate + indirect]
0x080 - 0x100:  forth stacks [not accessible with @ and !]
0x100 - 0x1ff:  circular buffers
0xf80 - 0xfff:  access ram, control regs, [immediate only]


program memory map:
0x0000 - 0x0400:  xt vectors [upper limit depends on application]

)
host
load arch/18f452.f   ( symbolic constants )
load asm/16bit.f     ( basic 16bit core assembler )

( stc specific MACROS - map forth to assembler )
load stc16/stack.f     ( stack manips )
load stc16/lit.f       ( load literal macros )
load host/constant.f   ( target constants in terms of lit, )

target
load arch/18f452.f     ( load machine constants in target dict )

host
load stc16/target.f    ( native code compiler for target words )    
load stc16/bit.f       ( bit level instructions )    
load stc16/data.f      ( load/store and data processing )
load stc16/rs.f        ( return stack )
load stc16/indirect.f  ( indirect code/data access )
load stc16/cbra.f      ( conditional branching )
load stc16/mem.f       ( target data memory allocation )
load stc16/isr.f       ( isr macros )

load host/view.f       ( make target look like a standard forth )
