( -*- forth -*- )
( ********** 18f452 VARIABLE AND MATH MACROS  ************ )

( load / store primitives )


host

( optimizing macros )
: !,
    <lit,                             ( true indirect will be defined later )
    dup? if rewind movwf, exit then   ( "dup x !"   ->  "movwf x" )
    lit00? litff? or if <lit,         ( all 0/1 lits )
	if setf, else clrf, then exit
    then movwf, drop, ;               ( default )


: @,
    <lit, save, movf, ;       ( literal fetch )


( TOS words )
: neg,      lit? if <lit, neg lit, exit then 0x00 sublw, ;
: not,      lit? if <lit, not lit, exit then cond? if invert exit then 0xff xorlw, ;

( 2 argument words operating on TOS and 2nd ) ( -- )
: (+),    POSTDEC0 addwf, ;
: (-),    POSTDEC0 subwf, ;  ( yes, this seems to be correct )   
: (xor),  POSTDEC0 xorwf, ;
: (and),  POSTDEC0 andwf, ;
: (or),   POSTDEC0 iorwf, ;


: stack:_  lit?_ not_ if_ ;     ( check if lit, if not, execute first block )
: lit:_    exit_ then_ <lit,_ ; ( else undo lit and execute second block )

( do literal constant )
: +,    stack: (+),   lit: addlw, ;
: -,    stack: (-),   lit: neg addlw, ;
: or,   stack: (or),  lit: iorlw, ;
: xor,  stack: (xor), lit: xorlw, ;
: and,  stack: (and), lit: andlw, ;

( do literal register store )
: +!,       <lit, addwf, f, drop, ;
: -!,       <lit, subwf, f, drop, ;
: or!,      <lit, iorwf, f, drop, ;
: xor!,     <lit, xorwf, f, drop, ;
: and!,     <lit, andwf, f, drop, ;

: not!,     <lit, comf, f, ;
: neg!,     <lit, negf, ;

( these are explicit. not automaticly optimized. )
: 1+,       WREG incf, ;
: 1-,       WREG decf, ;
: 1+!,      <lit, incf, f, ;
: 1-!,      <lit, decf, f, ;


: rot<c,    WREG rlcf, ;
: rot>c,    WREG rrcf, ;

: <<,       clc, rot<c, ;
: >>,       clc, rot>c, ;

: rot<,     WREG rlncf, ;
: rot>,     WREG rrncf, ;

: nswap,    WREG swapf, ;

: rot<c!,   <lit, rlcf, f, ;
( : c+!,      <lit, addwfc, f, ;   )


: -pick,    PLUSW0 movf, ;
: pick,     lit? if <lit, -1 * lit, -pick, exit then neg, -pick, ;


: max,      INDF0 cpfsgt, INDF0 movwf, drop, ;
: min,      INDF0 cpfslt, INDF0 movwf, drop, ;


host