( -*- forth -*- )

( target forth code )

host
: access-a!, 
    FSR2L movwf,     ( store low byte )
    FSR2H clrf,      ( clear high byte )
    WREG 7 btfsc,    ( if high bit.. )
    FSR2H setf,      ( ..set high byte )
    drop, ;

target

: (@)  access-a! @a ;
: (!)  access-a! !a ;

( redefine some macros to compile non-literal @ ! and memory operations
this is a slow, because we simulate access bank access.

NOTE that a reg will be garbage when using these.
best to use a reg directly )

host
<h'> @, : @, lit? not if (@), exit then [ _ ] ;
<h'> !, : !, lit? not if (!), exit then [ _ ] ;

<h'> +!,   : +!,   lit? not if (@), +,   !a, exit then [ _ ] ;
<h'> -!,   : -!,   lit? not if (@), -,   !a, exit then [ _ ] ;
<h'> and!, : and!, lit? not if (@), and, !a, exit then [ _ ] ;
<h'> or!,  : or!,  lit? not if (@), or,  !a, exit then [ _ ] ;
<h'> xor!, : xor!, lit? not if (@), xor, !a, exit then [ _ ] ;


target
( slower stack shuffling ops implemented as asm words.
  this is to prevent temp registers. they use RS instead. )
( TODO: check these !! )
: swap push TOSL ! TOSH ! TOSL @ TOSH @ pop ;
( : over push [ INDF0 TOSL movff, ] TOSL @ pop ; 
: 2dup push [ INDF0 TOSH movff, TOSL movwf, ] TOSH @ TOSL @ pop ; )

: over 1 pick ;
: 2dup 1 pick 1 pick ;
: rot  push TOSL ! TOSH ! [ TOSH PREINC0 movff, TOSL PREINC0 movff, ] pop ;

: a>x [ FSR2L PREINC1 movff, FSR2H PREINC1 movff, ] ;
: x>a [ POSTDEC1 FSR2H movff, POSTDEC1 FSR2L movff, ] ; )



host



