( -*- forth -*- )

( the 18f has 3 indirect adressing registers
FSR0 = data stack pointer
FSR1 = temp stack
FSR2   = scratch register a: data memory access, state = garbage in interrupts
TBLPTR = scratch register p: program memory access

( temp stack )

: >x?    PREINC1 0xff and MOVWF or prev t@ = ;

( : dup>x, PREINC1 movwf, ; )
( : >x,    storer PREINC1 movwf, ;
: x>,    save, POSTDEC1 movf, ; )

macro
: >x     PREINC1 ! ;
: x>     POSTDEC1 @ ;

host

: x,     save, >x? if exit then INDF1 movf, ; ( don't compile if prev inst was >x )
: @x,    lit? if <lit, neg lit, else neg, then PLUSW1 movf, ;
: xdrop, POSTDEC1 movf, f, ;
: x-,    INDF1 decf, f, ;

( FSR2 is used also for non-literal @/! )

: ah, FSR2H lit, ;
: al, FSR2L lit, ;
: pl, TBLPTRL lit, ;
: ph, TBLPTRH lit, ;

macro

: a@ ( -- lo hi ) al @ ah @ ;     ( load a register on stack )
: a! ( lo hi -- ) ah ! al ! ;     ( store stack into a register )

: p@ ( -- lo hi ) pl @ ph @ ;
: p! ( lo hi -- ) ph ! pl ! ;

host

: seta,  2 lfsr,  ;      ( macro version: [ 0x123 a ] )
: @a+,  POSTINC2, @, ;  ( fetch from address in a, increment a )
: !a+,  POSTINC2, !, ;  ( store )
: @a,   INDF2, @, ;
: !a,   INDF2, !, ;

( fetch/store relative to a )
: @i,  PLUSW2 movf, ;
: !i,  INDF0 PLUSW2 movff, drop, drop, ;

: setp,
    save, lohi
    movlw, TBLPTRH movwf,
    movlw, TBLPTRL movwf,
    drop, ;
: @p+,
    save, TBLRD*+ , TABLAT movf, ;
: !p+,
    TABLAT movwf, TBLWT*+ , drop, ;





host
( TODO: tick should allocate a vector )