( -*- forth -*- )

( basic monitor to implement interactive target forth
there are 2 tethering models:

target:  provides words to access data and code, uses
         host data stack

link:    simulated target only forth )

( requires 'receive' and 'transmit', and
the flash programming words 'flash' 'program' and 'erase')


( control xts )
: jsr    push receive TOSL ! receive TOSH ! ;
: ack    0xff transmit ;
: bye    rdrop ;

( programming )
: ferase   flash erase ;
: fprog    flash program ;

( bytecode interpreter main loop )
: interpreter receive execute interpreter ;

( block transfer )
: n@p+  for @p+ transmit next ;
: n!p+  for receive !p+ next ;
: n@a+  for @a+ transmit next ;
: n!a+  for receive !a+ next ;

host
: [msg], forchar lit, transmit, nextchar ;

( identification )
target
: ping [msg] PING ;

( compiled macros )
: lda  receive receive a! ;
: ldp  receive receive p! ;

( xt vectors )

( reset )
' receive   0x1 vector!
' transmit  0x2 vector!
' jsr       0x3 vector!

( 4 words reserved for high pri isr @ 0x0008 )
( 0x4 vector! )
( 0x5 vector! )
( 0x6 vector! )
( 0x7 vector! )

' lda     0x8 vector!
' ldp     0x9 vector!
' ack     0xa vector!
' bye     0xb vector!


( ram isr vectors 
variable ihigh0
variable ihigh1
variable ilow0
variable ilow1 )

( terminate interrupt chains 
chainhi terminal : ramhi push ihigh0 @ TOSL ! ihigh1 @ TOSH ! ;
chainlo terminal : ramlo push ilow0 @ TOSL ! ilow1 @ TOSH ! ; )


    