( -*- forth -*- )
( literal and optimization
there are only 2 possible code transformations:
/dup lit/ -> //             undo the lit completely
/lit/     -> /drop/         undo an optimized lit
                            the drop can be undone by a following save, )

( get literal from last instruction )
: get-lit  prev t@ 0xff and ;
: lit,     save, record movlw, ;
: lit?     prev t@ 0xff00 and MOVLW = last? and ;
: undo-lit rewind dup? if rewind else drop, then ;

( special case lits )
: lit00?    prev t@ MOVLW = last? and ;
: litff?    prev t@ MOVLW 0xff or = last? and ;

( inverse of lit, )
: <lit,    lit? if get-lit undo-lit exit then e-nolit ;

( i.e. for instructions that have only literal arguments,
  and no need to work around them )
: need-lit  lit? if <lit, else e-nolit then ;
: need-2lit need-lit need-lit swap ;


: ]L# lit, ] ;

( set vector )
<h'> lit,     <lit,>     h!
