( -*- forth -*- )

host

( data memory map )
0x80   constant data     ( data stack bottom )
0x90   constant temp     ( temp stack bottom )
0xa0   constant buffers  ( buffer allocation space )

( code memory map )
0x0020 constant kernel   ( kernel start )
0x0000 constant xt-table ( xt jump table start )

( misc config )
40 MHz constant fosc
19200  constant baud



( target forth )
load stc16/stc.f             ( macros )
load stc16/serial_simple.f   ( no interrupts )
load stc16/program.f         ( flash programming )
load stc16/execute.f         ( xt vectors )
load stc16/interpreter.f     ( simple xt interpreter + support )

macro
: initports 0 TRISA ! 0 TRISB ! 0 TRISC ! ;

target




( entry point )
: main
    initstacks      ( setup DS RS XS )
    initports       ( set all ports to output )
    initserial      ( init serial port )
    interpreter     ( start interpreter )
    [ 0x200 call, ] ( fall through to shifted reset vector ) ;


( set point past bootblock and set marker )
0x200 there! marker --user--

( set reset and interrupt vectors )
' main 0x0 vector!
0x0208 0x4 vector!
0x0218 0xc vector!

host

( now dump out the dictionary for the monitor,
so it can be loaded later without recompiling
and uploading. )
saveforth image/current.f   ( current, incremental image )

: reload    [empty-load] stc16/interactive.f ;  ( reload current image )
: recompile [empty-load] stc16/monitor.f ;      ( recompile monitor )


( host interactive support code )
load host/interactive.f
load wisp/18f452.f



