( -*- forth -*- )

host

( simpler version not using interrupts )

( fast baud rate divisor )
: >brg 16 * fosc swap / 1 - ;


target

( give status bits a sane name )
RCSTA OERR 2constant overrun
RCSTA FERR 2constant frame
RCSTA CREN 2constant rx-en
TXSTA TRMT 2constant tx-ready
PIR1  RCIF 2constant rx-ready

( save/restore implemented as macros )

macro
: rx-reset rx-en low rx-en high ;
target

: receive
    begin rx-ready high? until
    overrun high?        if rx-reset receive exit then
    RCREG @ frame high?  if drop receive exit then  ;

: transmit
    begin tx-ready high? until TXREG ! ;


: initserial
    TRISC 7 high TRISC 6 low   ( set tris bits for Tx and Rx )
    [ baud >brg ]L SPBRG !     ( set baud rate )
    0x24 TXSTA !               ( enable transmission and high baud rate )
    0x90 RCSTA !               ( enable serial port and reception )
;


( these init chains are not flexible enough
to do automaticly
' serialinit >init )

