( -*- forth -*- )
( task switching )

( saving the temp and data stacks is a lot of work and
uses more memory, but it's the most flexible solution.

when there are not many tasks, and the data and temp stack
need no saving, we could use the return stack, since it's 31
cells deep. this does requires to use a reserved space for
interrupts, otherwize each task needs to provide

* separate space for interrupt, say 3 cells
* shallow yield points
* large 'common space' for applications at SP=0

an alternative to tasks for yield behaviour, when it is
fixed, is a jump table with 'program counter'. or a state
machine.

)  


host
nextbuffer constant tasks 

target

variable current ( current task )

here
: resume ( task -- )
    [ tasks ]a!           ( task switcher context )
    STKPTR @ current @ !i ( save current stack pointer )
    @i dup current !      ( set new task current )
    STKPTR ! ;            ( switch )
    
reset!

( NOT TESTED )

( simple round robin scheduler.
each task waits on a certain condition. check is provided
by the task itself, in the form of:

bit wait

this compiles a small loop:

: wait bit high? if exit then yield scheduler wait ;

)

0 here savehex task.hex

