( -*- forth -*- )


( usbstamp monitor:
preliminary version: mapped at 0x1000, combined with black box C code )

host

( data memory map )
0x80   constant data     ( data stack bottom )
0x90   constant temp     ( temp stack bottom )
0xa0   constant buffers  ( buffer allocation space )

( code memory map )
0x1020 constant kernel   ( kernel start )
0x1000 constant xt-table ( xt jump table start )

( misc config )
40 MHz constant fosc
19200  constant baud



( target forth )
load stc16/stc.f             ( macros )
load stc16/program.f         ( flash programming )
load stc16/execute.f         ( xt vectors )
load stc16/foreign.f         ( foreign code interface )
target
: receive  dup forth>r [ 0xaa00 acall, ] r>forth ;
: transmit forth>r     [ 0xbb00 acall, ] r>forth drop ;

load stc16/interpreter.f     ( simple xt interpreter + support )

target

( entry point )
: main
    initstacks       ( setup DS RS XS )
    interpreter      ( start interpreter )
    [ 0x1200 call, ] ( fall through to shifted reset vector ) ;


( set point past bootblock and set marker )
' main 0 vector!
0x1200 there! marker --user--

host

( now dump out the dictionary for the monitor,
so it can be loaded later without recompiling
and uploading. )
saveforth image/usbstamp_current.f   ( current, incremental image )

: reload    [empty-load] stc16/usbstamp_interactive.f ;  ( reload current image )
: recompile [empty-load] stc16/usbstamp_monitor.f ;      ( recompile monitor )



( host interactive support code )
load host/interactive.f
load wisp/18f452.f



