( -*- forth -*- )
host


( literal 8 bit commands )
: note     0xf and 0x80 or x ;
: note1    0xf and 0x90 or x ;
: note2    0xf and 0xa0 or x ;
: tick     1 - 0xf and 0xb0 or x ;
: octave   0x7 and 0xc8 or x ;
: chirp    0x7 and 0xd0 or x ;
: range    0x7 and 0xd8 or x ;


( literal 16 bit commands )
: period   0xf0 x x ;
: period1  0xf1 x x ;
: period2  0xf2 x x ;

: >e  ( control synth mod mod -- ) pack-engine 0xf3 x x ;
: e!  ( control synth mod mod -- ) pack-engine 0xf4 x x ;
: >t  ( ticks -- ) 0xf5 x x ;
    
: hihat    0xc0 x ;
: snare    0xc7 x ;

( zero operand 8bit commands )
: ret      0xf8 x ;
: e-drop   0xf9 x ;  ( drop engine )
: e-dup    0xfa x ;  ( dup engine )
: e-swap   0xfb x ;  ( swap engine )

( zero operand commands )
: pwm      0xfc x ;

( 'forth' compiler )
(
: exiter   vector <exit,> ret ;
: compiler vector <compile,> x ;
: inliner  vector <lit,> note ; 
: #: accept xere (tdict) ( ] ; )


: junk patch 128 for random x next ; 


: fatbeat
    patch

    0 0 1 0 >e
    13 x
    2 octave
    0 note pwm
    snare 1 tick
    hihat
    13 x
    hihat 1 tick
    0 x

    0 period
    3 chirp
    1 0 0 0 >e
    1 tick
    e-drop
    ret

    
;



: mellowbeat
    patch

    13 x hihat 11 note 
    13 x snare 8 note 
    13 x hihat 1 note 
    13 x snare 7 note 
    0 x

    2 period1
    
    2 octave 
    1 tick
    snare
    1 tick

    20 period
    1 0 0 0 >e

    hihat 
    1 tick

    e-drop
    0 note 


    hihat
    1 tick

    ret ; 

: mellow
    patch

    10 period
    1 0 0 0 >e
    1 tick

    2 octave
    0 0 1 0 >e
    0 note
    7 note1

    1 tick
    snare 2 tick
    
    0 x ;

: poly
    patch
    2 octave
    0 note
    7 note2
    0 2 1 0 >e
    4 octave
    0 note1 2 tick
    7 note1 2 tick
    2 note1 3 tick
    2 octave
    1 note
    4 octave
    5 note1 2 tick
    4 note1 2 tick
    3 note1 3 tick
    6 note1 4 tick
    12 note1 4 tick

    0 x ;


: testnoise2
    patch
    2 octave
    0 4 1 0 >e
    0 period1
    4 tick
    3 note
    e-drop
    2 tick snare
    2 tick
    0 x ;

: testnoise3
    patch
    2 octave

    0 3 0 0 >e
    4 tick
    0 4 0 1 >e

    100 period1 ( divider )
    99 period2 ( xmod )
    
    4 tick
    0 x ;

: woink
    patch

    3 chirp 3 range 2 0 0 0 >e 1 tick
    0 chirp 5 range 1 0 0 0 >e snare 1 tick
    1 chirp 2 range 1 0 0 0 >e 1 tick
    
    1 note 7 note1 13 note2 0 0 1 1 >e 1 tick

    3 chirp 3 range 2 0 0 0 >e 1 tick
    0 chirp 1 range 2 0 0 0 >e snare 1 tick
    1 chirp 2 range 1 0 0 0 >e 1 tick
    
    1 note 7 note1 13 note2 0 0 1 1 >e 1 tick
    
    0 x ;

: testnoise4
    patch
    2 octave
    0 0 1 0 >e 0 note
    pwm 4 tick
    2 octave
    7 note pwm 3 tick
    0 x


;


: testnoise5
    patch
    2 octave
    40 period
    41 period1
    42 period2
    0 0 1 1 >e

    0 x

    ;
: heavypwm
    patch
    2 octave
    0 note pwm
    0 0 1 1 >e

    3 tick
    3 note pwm
    5 tick
    7 note pwm
    2 tick

    0 x

;




: noprog
    patch 0 x ;

: randprog  patch 128 for random 0x80 or x next ;
: randprog2 patch 64 for random 0x80 or x 1 tick next ;

