( -*- forth -*- )
load wisp/wisp.f
0x3 algo

( configuration )
: x 1write ;
: write-fuses
    fuses 0x300001 jump
    ( 0x300001 ) 0x26 x ( HSpll, no osc switch )
    ( 0x300002 ) 0x0e x ( put, bod 2.5V )
    ( 0x300003 ) 0x0e x ( no wdt, 1:128 )
    ( 0x300004 ) 0x00 x 
    ( 0x300005 ) 0x01 x ( ccp2 mux rc1 )
    ( 0x300006 ) 0x85 x ( lvp, stack overflow reset )
    ( 0x300007 ) 0x00 x 
    ( 0x300008 ) 0x0f x ( code protect off )
    ( 0x300009 ) 0xc0 x ( ee protect off, boot protect off )
    ( 0x30000a ) 0x0f x ( table write protect off )
    ( 0x30000b ) 0xe0 x ( ee write protect off, table write protect boot off )
    ( 0x30000c ) 0x0f x ( table read protect off )
    ( 0x30000d ) 0x40 x ( table read protect boot off )
;

: .fuses
    fuses 0x300001 dup jump
    13 for dup .x [w] R check 1w> .2x cr 1 + next drop ;


( with byte addressing and little endian encoding, wisp
wants our 16bit words swapped )
: byteswap dup 0xff and 8 << swap 8 >> 0xff and or ;

( for 18f, we use the read/write algos that operate on
8 bytes at a time, autoincrementing )

: erase       3 algo 0xe (program) ;
: wcode       3 algo code ;
: rcode       6 algo code ;

: chunks      0 there 1 - 8 / 1 + ;
: progress     ( a -- a )   0xd emit dup .x space ;
: write-tick   ( a -- a+8 ) 4 for dup t@ byteswap >w 2 + next [w] W check ;
: write-buffer ( -- )       chunks for progress write-tick next drop ;

: verify-tick    ( a -- a+8 ) [w] R check 0 4 for over t@ byteswap w> = not or >r 2 + r> next if [c] ! emit cr then ;
: verify-buffer  ( -- )       chunks for progress verify-tick next drop ;

: burn   wisp erase wcode write-buffer write-fuses ;
: verify rcode verify-buffer ;
